import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import sinon, { type SinonStubbedInstance } from 'sinon';

import AlertService from '@/shared/alert/alert.service';

import StrutturaDetails from './struttura-details.vue';
import StrutturaService from './struttura.service';

type StrutturaDetailsComponentType = InstanceType<typeof StrutturaDetails>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const strutturaSample = { id: 123 };

describe('Component Tests', () => {
  let alertService: AlertService;

  afterEach(() => {
    vitest.resetAllMocks();
  });

  describe('Struttura Management Detail Component', () => {
    let strutturaServiceStub: SinonStubbedInstance<StrutturaService>;
    let mountOptions: MountingOptions<StrutturaDetailsComponentType>['global'];

    beforeEach(() => {
      route = {};
      strutturaServiceStub = sinon.createStubInstance<StrutturaService>(StrutturaService);

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'router-link': true,
        },
        provide: {
          alertService,
          strutturaService: () => strutturaServiceStub,
        },
      };
    });

    describe('Navigate to details', () => {
      it('Should call load all on init', async () => {
        // GIVEN
        strutturaServiceStub.find.resolves(strutturaSample);
        route = {
          params: {
            strutturaId: `${123}`,
          },
        };
        const wrapper = shallowMount(StrutturaDetails, { global: mountOptions });
        const comp = wrapper.vm;
        // WHEN
        await comp.$nextTick();

        // THEN
        expect(comp.struttura).toMatchObject(strutturaSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        strutturaServiceStub.find.resolves(strutturaSample);
        const wrapper = shallowMount(StrutturaDetails, { global: mountOptions });
        const comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
